Package jebl.evolution.sequences

# Interface SequenceType

public interface SequenceType
Interface for sequences data types.

Version:
  $Id: SequenceType.java 849 2007-12-06 00:10:14Z twobeers $
Author:
  Andrew Rambaut, Alexei Drummond

## Nested Class Summary

Nested Classes
Modifier and Type
Interface
Description
`static class`
`SequenceType.Utils`

## Field Summary

Fields
Modifier and Type
Field
Description
`static final SequenceType`
`AMINO_ACID`
`static final SequenceType`
`CODON`
`static final SequenceType`
`NUCLEOTIDE`

## Method Summary

Modifier and Type
Method
Description
`int`
`getCanonicalStateCount()`
Get number of canonical states
`List<? extends State>`
`getCanonicalStates()`
Get a list of canonical states ordered by their indices.
`int`
`getCodeLength()`
`State`
`getGapState()`
Get state corresponding to a gap
`String`
`getName()`
name of data type
`String`
`getNexusDataType()`
`State`
`getState(char code)`
Get state whose code is the one-character string consisting only of code.
`State`
`getState(int index)`
Get state corresponding to a state index
`State`
`getState(String code)`
Get state corresponding to a string code
`int`
`getStateCount()`
Get number of states including ambiguous states
`List<? extends State>`
`getStates()`
Get a list of states ordered by their indices.
`State`
`getUnknownState()`
Get state corresponding to an unknown
`boolean`
`isGap(State state)`
`boolean`
`isUnknown(State state)`
`State[]`
`toStateArray(byte[] indexArray)`
Converts an array of state indices into an array of State objects for this SequenceType
`State[]`
`toStateArray(String sequenceString)`
Converts a string of state codes into an array of State objects for this SequenceType

## Field Details

### NUCLEOTIDE

static final SequenceType NUCLEOTIDE

### AMINO_ACID

static final SequenceType AMINO_ACID

### CODON

static final SequenceType CODON

## Method Details

### getStateCount

int getStateCount()
Get number of states including ambiguous states

Returns:
  number of states

### getStates

List<? extends State> getStates()
Get a list of states ordered by their indices.

Returns:
  a list of states

### getCanonicalStateCount

int getCanonicalStateCount()
Get number of canonical states

Returns:
  number of states

### getCanonicalStates

List<? extends State> getCanonicalStates()
Get a list of canonical states ordered by their indices.

Returns:
  a list of states

### getState

State getState(String code)
Get state corresponding to a string code

Parameters:
  `code` - a string code
Returns:
  the state with the given code, or null if there is no such state

### getState

State getState(char code)
Get state whose code is the one-character string consisting only of code.

Parameters:
  `code` -
Returns:
  the state with the given code, or null if there is no such state

### getCodeLength

int getCodeLength()

Returns:
  the length, in characters, of a state, when encoded as a string. i.e. 1 for Nucleotides and AminoAcids and 3 for Codons.

### getState

State getState(int index)
Get state corresponding to a state index

Parameters:
  `index` - a state index
Returns:
  the state

### getUnknownState

State getUnknownState()
Get state corresponding to an unknown

Returns:
  the state

### getGapState

State getGapState()
Get state corresponding to a gap

Returns:
  state

### isUnknown

boolean isUnknown(State state)

Returns:
  true if this state is an unknown state

### isGap

boolean isGap(State state)

Returns:
  true if this state is a gap

### getName

String getName()
name of data type

Returns:
  string describing the data type

### getNexusDataType

String getNexusDataType()

Returns:
  datatype inside a nexus characters block, if any.

### toStateArray

State[] toStateArray(String sequenceString)
Converts a string of state codes into an array of State objects for this SequenceType

Parameters:
  `sequenceString` -
Returns:
  the State array

### toStateArray

State[] toStateArray(byte[] indexArray)
Converts an array of state indices into an array of State objects for this SequenceType

Parameters:
  `indexArray` -
Returns:
  the State array